//----------------------------------------------------------------
/* Pyramid & Pyramid Break
/* Written by Azuron 1991 12.23(Mon.)
/* Oh!X 1992-3
// V3.20以降専用
//----------------------------------------------------------------

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

if cardInit()<>0 then {
	print localizedString("カードパターンが読めません","Card data can not read.")
	end
}

//----------------------------------------------------------------
// 以下ゲーム実体
//----------------------------------------------------------------
// お約束部分
enum
	FNTSZ=16
	KEY_SPACE =' '
	KEY_GIVEUP='!'
endenum
str FONT="Migu-1M-Regular"

font(FONT,FNTSZ):// 先にフォントを設定してからwidth()を設定する
width(96):// テキスト文字フォントサイズを算出させる
// 以下テキスト描画はグラフィックモードで行う(X68のプログラムのままではグラフィックとテキストで座標が合わないので)

vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1+B_GPAGE2+B_GPAGE3)

width(0)
tAtrb(ATRB_CLEAR):// グラフィックモードでテキスト文字の下地を消す

// bitmapOpen()はページ毎に行う必要がある
apage(GPAGE3):bitmapOpen(0,0,YES)
apage(GPAGE2):bitmapOpen(0,0,YES)
apage(GPAGE1):bitmapOpen(0,0,YES)
apage(GPAGE0):bitmapOpen(0,0,YES)

// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate
setTouchArea(0,0,0,0,0,NO)

dim int	touchNo(20)	:// タッチエリア番号 / touch area number
int touchallcnt=0	:// タッチエリア数   / the number of touch area

//----------------------------------------------------------------

int i,j,r,da,cp,sp,game,area=0,mode=0,count
dim int cd(52),ba(28),col(28)
dim int sute(24),rf(28),xy(56),grd(17400)

// 音声データ読み込み
dim int snd(3)
enum
	pasa=1
	boo
endenum

for i=pasa to boo
//	gLocate(0,35+i)
//	print "pyramid"+str$(i)+".mp3";
	snd(i)=a_setPlayData("pyramid"+str$(i)+".mp3")
//	print "/";snd(i)
next
/*
prep0()
vinit1()
r=menu():// ゲーム選択
/* メイン
while r=NO
	datmake()
	vinit2()
	shuffle()
	if game then prep2() else prep1()
	layout()
	virtual()
	hand_put()
	//
	setFunctionKey(0,localizedString("ギブアップ","Give up"),KEY_GIVEUP)
	displayFunctionKey(YES,0,0)
	repeat
		if game then r=play2() else r=play1()
	until r<>0
	displayFunctionKey(NO)
	//
	percentage()
	if r=2 then perfect()
	r=menu():// ゲーム選択
endwhile
/* 終了
// 音声バッファー開放
for i=pasa to boo
	a_end(snd(i))
next

// bitmapはページごとに確保されているので、それぞれを開放する必要がある
apage(GPAGE3):bitmapClose()
apage(GPAGE2):bitmapClose()
apage(GPAGE1):bitmapClose()
apage(GPAGE0):bitmapClose()

end

/*-------------------------------------

func int play1()
/* 遊戯(Pyramid)
int  x,y,c1,c2,p1,p2,x0,x1,y0,y1,cc,r=0

	kbclr()
	
	/* 1st card select
//	gLocate(0,35):print "1st"
	repeat
//gLocate( 0,40):print "      "
//gLocate(20,40):print "      "
		p1=select1(0)
//gLocate(0,40):print "p1=";p1
		if p1=-2 then continue
		if p1=-3 then suteru():break
		if p1=-6 then {
			if giveup() then r=1
			break
		}
		if p1=-4 then {
			cc=sute(sp):x0=sp*14+60:y0=400
		} else {
			if rf(p1) then reverse(p1):break
			cc=ba(p1):x0=calcx(p1):y0=calcy(p1)
		}
		c1=rank(cc):Lon(x0,y0)
		if c1=13 then {
			if p1=-4 then sute_take() else ba_take(p1)
			break
		}
		/* 2nd card select
//gLocate(0,35):print "2nd"
		repeat
			p2=select1(1)
//gLocate(20,40):print "p2=";p2
			if p2=-6 then {
				if giveup() then r=1
				Loff(x0,y0):// 1枚目もキャンセル
				goto "PL1"
			}
			if p2=-1 then reverse(p2):continue
			if p2=-2 or p2=-3 then continue
//			if p2=-2 or p2=-3 or p1=p2 then continue
			if p2=p1 then Loff(x0,y0):break:// 同じカードを選択したらキャンセル
//			if p2=-5 then Loff(x0,y0):break
			if p2=-4 then {
				cc=sute(sp):x1=sp*14+60:y1=400
			} else {
				if rf(p2) then reverse(p2):continue
				cc=ba(p2):x1=calcx(p2):y1=calcy(p2)
			}
			c2=rank(cc)
			if c1+c2=13 then {
				Lon(x1,y1)
			} else {
				SE(boo)
				continue
			}
			if p1=-4 then sute_take() else ba_take(p1)
			if p2=-4 then sute_take() else ba_take(p2)
			break
		until 0:// 無限ループ
		break
	until 0:// 無限ループ
label "PL1"
	if endcheck() then r=2
	return(r)
endfunc

/*-------------------------------------

func int select1(sw)
/* カード選択(Pyramid)
/* sw=0:第1カード選択,1:第2カード選択
int n,br,mx,my
	msoff()
	//
	// タッチされるのを待つ
	while getTouchStatus()=TOUCH_NONE
		br=inkey()
		if br<>0 then {
			return(-6):// giveup
		}
	endwhile
	//
	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	mx=tpoint(0)
	my=tpoint(1)
	/*
	while 1
//		if br and sw=0 then n=-6:break:// giveup
//		if br and sw=1 then n=-5:break:// キャンセル
		apage(GPAGE3)
		n=bitmapPoint(mx,my)
//gLocate( 0,32):print "col=";n
//gLocate(20,32):print "mx,my=";mx;",";my
//gLocate(20,33):print "          "
		if n=0 then {
//gLocate(40,32):print "n=0->-2"
			n=-2:break
		}
		if my>=400 then {
			if n=2 then n=-3 else n=-4
			break
		}
		if mode then n=pget2(mx,my) else n=pget1(mx,my)
//gLocate(20,33):print "pget=";n
		if chk1(n) then {
//gLocate(40,32):print "chk1(n)->-2"
			n=-2
		}
		break
	endwhile
	return(n)
endfunc

/*-------------------------------------

func int play2()
/* 遊戯(Pyramid Break)
int n,br,mx,my,r=0
	msoff()

	// タッチされるのを待つ
	while getTouchStatus()=TOUCH_NONE
		br=inkey()
		if br<>0 then {
			return(giveup())
		}
	endwhile
	//
	dim float tpoint(1)
	int touchCnt=getTouchPoint(tpoint)
	mx=tpoint(0)
	my=tpoint(1)
	/*
	while 1:// 無限ループ
		if mx<88 then {
			if mode   and my>300 then hand():break
			if mode=0 and my<196 then hand():break
		}
		r=select2(mx,my)
		break
	endwhile
	return(r)
endfunc

/*-------------------------------------

func int select2(x,y)
/* カード選択(Pyramid Break)
int p
	if mode then p=pget2(x,y) else p=pget1(x,y)
	if p=-1 then return(0)
	if rf(p) then reverse(p):return(0)
	if chk1(p) or chk2(p) then return(0)
	base_card(0,100+mode*200,ba(p))
	ba_take(p)
	if endcheck() then return(2)
	return(0)
endfunc

/*-------------------------------------

func int pget1(x,y)
/* どのカードを選んだか？(1)
int y0=288,y1=240,p
	if game then y0=388:y1=340
	apage(GPAGE3)
	p=bitmapPoint(x,y)
	if p=0 then return(-1)
	if y>=y0 then {
		p=p+15
	} else {
		if y>=y1 then if p>0 and p<7 then p=p+15
	}
	return(p-1)
endfunc

/*-------------------------------------

func int pget2(x,y)
/* どのカードを選んだか？(2)
int y0=192,y1=96,p
	if game then y0=292:y1=196
	apage(GPAGE3)
	p=bitmapPoint(x,y)
	if p=0 then return(-1)
	if y>=y0 then {
		p=p+15
	} else {
		if y>=y1 then if p<8 then p=p+15
	}
	return(p-1)
endfunc

/*-------------------------------------

func sute_take()
/* 捨て札を取る(Pyramid)
int x
	x=sp*14+60
	apage(GPAGE0)
	fill16X68(x,400,x+CARD_WX-1,495,0)
	if sp>0 then {
		cardPut(x-14,400,sute(sp-1),NO)
		SE(pasa)
	}
	sute(sp)=0:sp=sp-1
	apage(GPAGE3)
	bitmapFill(60,400,485,495,0)
	x=sp*14+60
	if sp>-1 then bitmapFill(x,400,x+CARD_WX-1,495,3)
endfunc

/*-------------------------------------

func suteru()
/* カードを捨てる(Pyramid)
int x
	sp=sp+1:x=sp*14+60
	apage(GPAGE0)
	cardPut(x,400,cd(cp),NO)
	line16X68(x-1,400,x-1,495,0)
	SE(pasa)
	apage(GPAGE3)
	bitmapFill(60,400,485		 ,495,0)
	bitmapFill( x,400,x+CARD_WX-1,495,3)
	sute(sp)=cd(cp)
	cp=cp+1
	if cp=52 then {
		apage(GPAGE0):fill16X68(   8,400,55,495,0)
		apage(GPAGE3):bitmapFill(8,400,55,495,0)
	}
	remain()
endfunc

/*-------------------------------------

func int reverse(p)
/* カードを表向きにする
int x,y
	if chk1(p) then return(1)
	rf(p)=0
	x=calcx(p):y=calcy(p)
	apage(GPAGE1)
	fill16X68(x,y+48,x+CARD_WX-1,y+CARD_WY-1,0)
	apage(GPAGE0)
	cardPut(x,y,ba(p),NO)
	SE(pasa)
	return(0)
endfunc

/*-------------------------------------
// このゲームではGPAGE3は仮想画面で表示はされないので、bitmapImgLoad()は不要

func ba_take(p)
/* 場のカードを取る
int x,y
//gLocate(40,36):print "ba_take:p=";p
	x=calcx(p)
	y=calcy(p)
	// 枠線を消す
	// iOSは描画が外にあふれるので一回り大きく消す
//	if YES then {
	apage(GPAGE0):fill16X68(   x-2,y-1 ,x+CARD_WX+1,y+CARD_WY+1,0)
	apage(GPAGE1):fill16X68(   x-2,y+47,x+CARD_WX+1,y+CARD_WY+1,0)
	apage(GPAGE2):fill16X68(   x-2,y+47,x+CARD_WX+1,y+CARD_WY+1,0)
//	} else {
//	apage(GPAGE0):bitmapFill(x-1,y          ,x+CARD_WX-1,y+CARD_WY-1,0):bitmapImgLoad()
//	apage(GPAGE1):bitmapFill(x-1,y+CARD_WY/2,x+CARD_WX-1,y+CARD_WY-1,0):bitmapImgLoad()
//	apage(GPAGE2):bitmapFill(x-1,y+CARD_WY/2,x+CARD_WX-1,y+CARD_WY-1,0):bitmapImgLoad()
//	}
	ba(p)=0
	apage(GPAGE3):bitmapFill(x-1,   y,x+CARD_WX-1,y+CARD_WY-1,0)
	SE(pasa)
	virtual()
	count=count+1
endfunc

/*-------------------------------------

func hand()
/* 手札を出す(Pyramid Break)
int  y
	if cp=52 then return()
	y=100+(mode*200)
	base_card(1,y,cd(cp))
	cp=cp+1
	remain()
	apage(GPAGE0)
	if cp=52 then fill16X68(40,y,87,y+CARD_WY-1,0)
endfunc

/*-------------------------------------

func base_card(sw,y,c)
/* 台札を表示(Pyramid Break)
	apage(GPAGE1)
	cardPut(424,y,c,NO)
	if sw then SE(pasa)
	da=c
endfunc

/*-------------------------------------

func remain()
/* 手札の残りを表示
int x,y,l
	i=len(itoa(52-cp))-1
	if game then x=60+(l*-4) else x=28+(l*-4)
	if game then y=200+mode*200 else y=498
	apage(GPAGE1)
	fill16X68(x-8,y,x+16,y+14,0)
	symbol16X68(x,y,itoa(abs(52-cp)),1,15,FONT,FNTSZ)
endfunc

/*-------------------------------------

func datmake()
/* 場のカードのXY座標データを作成
int  x,xx=234,y=0,ct=0,m=1
	if mode then m=7:xx=66
	if game then y=100
	/*
	for j=1 to 7
		x=xx
		for i=1 to m
		xy(ct)=x:xy(ct+1)=y
		x=x+56
		ct=ct+2
	next
	if mode then xx=xx+28:m=m-1 else xx=xx-28:m=m+1
	y=y+48
	next
endfunc

/*-------------------------------------

func int chk1(p)
/* カードが重なっていないか？
int x,y,c
	x=calcx(p)
	y=calcy(p)
	apage(GPAGE3)
	// ここはpoint()同士の比較なので色変換は不要
	c=bitmapPoint(x,y)
	if c<>bitmapPoint(x			 ,y+CARD_WY-1) then return(1)
	if c<>bitmapPoint(x+CARD_WX-1,y+CARD_WY-1) then return(1)
	return(0)
endfunc

/*-------------------------------------

func int chk2(p)
/* 台札にカードが置けるか？(Pyramid  Break)
int c,d,r=0
	c=rank(ba(p))
	d=rank(da)
	while 1
		if c=1 and d=13 then break
		if c=13 and d=1 then break
		if abs(d-c)<>1 then r=1
		break
	endwhile
	return(r)
endfunc

/*-------------------------------------

func int rank(c;int)
/* 数を調べる
	return((c-1) mod MAX_TRUMP+1)
endfunc

/*-------------------------------------

func layout()
/* レイアウト
int i,x,y,c
	for i=0 to 27
		x=calcx(i):y=calcy(i)
		ba(i)=cd(i)
		if rf(i) then c=0 else c=ba(i)
		apage(GPAGE0):cardPut(x,y,c,NO)
		// 外枠:厳密描画をするためbitmap関数を使う
		bitmapLine(x-1 	      ,y  ,x-1 	      ,y+CARD_WY-1,getgPalet16X68(1)):// 縦(左)
		bitmapLine(x   	      ,y  ,x+CARD_WX-1,y   	   	  ,getgPalet16X68(1)):// 横(上)
		bitmapLine(x+CARD_WX-1,y  ,x+CARD_WX-1,y+CARD_WY-1,getgPalet16X68(1)):// 縦(右)
		bitmapImgLoad()
		// 下横線はどのみち消えるので描画しない
		apage(GPAGE3):cardPut(x,y,ba(i),NO)
		/* 重なり部分を戻すため、下半分をコピーしておく
		int dy=CARD_WY/2
		apage(GPAGE0):bitmapGet(x,y+dy-1,x+CARD_WX-1,y+CARD_WY-1,grd)
		apage(GPAGE1):bitmapPut(x,y+dy-1,x+CARD_WX-1,y+CARD_WY-1,grd):bitmapImgLoad()
		apage(GPAGE3):bitmapGet(x,y+dy-1,x+CARD_WX-1,y+CARD_WY-1,grd)
		apage(GPAGE2):bitmapPut(x,y+dy-1,x+CARD_WX-1,y+CARD_WY-1,grd):bitmapImgLoad()
	next
endfunc

/*-------------------------------------

func virtual()
/* 仮想画面作成
/* カードごとに別の色で塗り分けてる
int i,x,y
//	mspos(x,y)
//	msarea(x,y,x+1,y+1)
	apage(GPAGE3)
	for i=0 to 27
		x=xy(i*2  )
		y=xy(i*2+1)
		if ba(i) then {
			bitmapFill(x,y,x+CARD_WX-1,y+CARD_WY-1,col(i))
		}
	next
//	msarea(0,0,511,511)
endfunc

/*-------------------------------------

func int giveup()
/* give up?
	dim str menues(1)
	str title$
	if isLocalizeJapan() then {
		title$="あきらめますか？"
		menues={"はい","いいえ"}
	} else {
		title$="Give up ?"
		menues={"Yes","No"}
	}
	switch selectMenu(title$,menues)
		case 0
			return(1)
	endswitch
	return(0)
endfunc

/*-------------------------------------

func percentage()
/* 成功率・破壊度
int i,n,t=0
str m,s
dim int xx(3)={296,280,270}
	if game then m="破壊度" else m="成功率"
	if not isLocalizeJapan() then m="Rate"
	for i=0 to 27
		if ba(i)=0 then t=t+1
	next
	s=itoa((t/28#)*100)
	n=xx(len(s)-1)
	/*
	apage(GPAGE0)
//	gLocate(0,33):print "size=";bitmapGetSize(170-2,210-2,339+2,305+2)
	bitmapGet(170-2,210-2,339+2,305+2,grd)
	//
		 flbx(170,210,339,305,8,9)
	   box16X68(172,212,337,303,9)
	symbol16X68(192,228,m    			,1.5,15,FONT,FNTSZ)
	symbol16X68(  n,228,s+"%"			,1.5,15,FONT,FNTSZ)
	symbol16X68(192+8,270,localizedString("画面をタップ","Tap screen"),1,15,FONT,FNTSZ)
	/*
	// タッチされるのを待つ
	while getTouchStatus()=TOUCH_NONE
	endwhile

	bitmapPut(170-2,210-2,339+2,305+2,grd)
	bitmapImgLoad()
endfunc

/*-------------------------------------

func perfect()
/* パーフェクト
int x
	apage(GPAGE0)
	fill16X68(154,246,359,271,1)
	apage(GPAGE2)
	symbol16X68(154,246,"CONGRATULATIONS!!",2,9,FONT,FNTSZ)
	apage(GPAGE0)
	for x=154 to 359
		line16X68(    x,246,    x,276,0)
		line16X68(513-x,246,513-x,271,0)
		x=x+1
		wait(0.04)
	next
	/*
	wait(1)
	apage(GPAGE2)
	symbol16X68(192+8,295,localizedString("画面をタップ","Tap screen"),1,13,FONT,FNTSZ)
	
	// タッチされるのを待つ
	while getTouchStatus()=TOUCH_NONE
	endwhile
	
	fill16X68(154,246,359,310,0)
endfunc

/*-------------------------------------

func vinit1()
/* 変数初期化(1)
int c=0
	for i=0 to 51:cd(i)=i+1:next
	// i=0〜14:c=0〜14
	// i=15:c=1
	// i=16〜27:c=2〜13
	for i=0 to 27
		if i=15 then c=1 else c=c+1
		col(i)=c
	next
endfunc

/*-------------------------------------

func vinit2()
/* 変数初期化(2)
	for i=0 to 27
		rf(i)=(area and((mode=0 and i<21) or mode and i<27))
	next
	cp=28:sp=-1:count=0
	da=cd(cp)
endfunc

/*-------------------------------------

func shuffle()
/* シャッフル
int i,a,b,c
	for i=1 to 99
		a=rand() mod 52
		b=rand() mod 52
		c=cd(a):cd(a)=cd(b):cd(b)=c
	next
endfunc

/*-------------------------------------

func msoff()
	// 前のタッチが離されるのを待つ
	while getTouchStatus()<>TOUCH_NONE:endwhile
endfunc

/*-------------------------------------

func endcheck()
/* クリアチェック
	return((count=28))
endfunc

/*-------------------------------------

func hand_put()
/* 手札表示
	apage(GPAGE0)
	if game=0 then cardPut( 8,400           ,0,NO):remain()
	if game   then cardPut(40,100+(mode*200),0,NO):hand()
endfunc

/*-------------------------------------

func Lon(x,y)
/* ボックス表示
	apage(GPAGE0)
	bitmapGet( x-1,y-1,x+CARD_WX  ,y+CARD_WY  ,grd)
//		box16X68(x  ,y  ,x+CARD_WX-1,y+CARD_WY-1,9)
		lineWidth(2)
		box16X68(x+1,y+1,x+CARD_WX-2,y+CARD_WY-2,9)
endfunc

/*-------------------------------------

func Loff(x,y)
/* ボックス消去
	apage(GPAGE0)
	bitmapPut(x-1,y-1,x+CARD_WX,y+CARD_WY,grd)
	bitmapImgLoad()
endfunc

/*-------------------------------------

func flbx(x0,y0,x1,y1,c0,c1)
/* fill&box
	fill16X68(x0,y0,x1,y1,c0)
	 box16X68(x0,y0,x1,y1,c1)
endfunc

/*-------------------------------------

func calcx(p)
/* X座標を求める
//gLocate(0,0):print "x:p=";p;"/p*2=";p*2;
	return(xy(p*2))
endfunc

/*-------------------------------------

func calcy(p)
/* Y座標を求める
//gLocate(30,0):print "y:p=";p;"/p*2=";p*2;
	return(xy(p*2+1))
endfunc

/*-------------------------------------

func SE(t)
/* Sound Effect
	a_play(snd(t))
	repeat:until a_stat(snd(t))=0
endfunc

/*-------------------------------------

func int menu()
int fexit=NO
	dim str menues(8)
	str title$
	if isLocalizeJapan() then {
		title$="ゲームメニュー"
		menues={
			"関東版 ピラミッド",
			"関西版 ピラミッド",
			"関東版 逆ピラミッド",
			"関西版 逆ピラミッド",
			"関東版 ピラミッド・ブレイク",
			"関西版 ピラミッド・ブレイク",
			"関東版 逆ピラミッド・ブレイク",
			"関西版 逆ピラミッド・ブレイク",
			"終了"
		}
	} else {
		title$="Game Menu ?"
		menues={
			"East Pyramid",
			"West Pyramid",
			"East Reverse Pyramid",
			"West Reverse Pyramid",
			"East Pyramid Break",
			"West Pyramid Break",
			"East Reverse Pyramid Break",
			"West Reverse Pyramid Break",
			"Exit"
		}
	}
	int n
	repeat
		n=selectMenu2(title$,menues)
	until n>=0
//	gLocate(0,32):print "n=";n
	switch n
		case 0:area=0:mode=0:game=0:break
		case 1:area=1:mode=0:game=0:break
		case 2:area=0:mode=1:game=0:break
		case 3:area=1:mode=1:game=0:break
		case 4:area=0:mode=0:game=1:break
		case 5:area=1:mode=0:game=1:break
		case 6:area=0:mode=1:game=1:break
		case 7:area=1:mode=1:game=1:break
		case 8:fexit=YES:break
	endswitch
	/*
	if not fexit then {
		wait(1)
		vpageX68(0,YES)
		for i=0 to 3
			apage(GPAGE3-i)
			wipe()
			//fill16X68(0,0,511,511,0)
		next
		apage(GPAGE3)
		bitmapFill(0,0,511,511,0)
		vpageX68(7,YES)
	}
	return(fexit)
endfunc

/*-------------------------------------

func prep0()
/* 準備
	srand(val(mid$(time$,4,2)+right$(time$,2)))
	setgPalet16X68(1,&h000000ff):// palet(1,0)
endfunc

/*-------------------------------------

func prep1()
/* 準備(Pyramid)
	apage(GPAGE0)
	symbol16X68(16,380,localizedString("手札","hand"),1,15,FONT,FNTSZ)
	apage(GPAGE3)
	bitmapFill(8,400,55,495,2)
endfunc

/*-------------------------------------

func prep2()
/* 準備(Pyramid  Break)
	apage(GPAGE0)
	symbol16X68(178,30			,"PYRAMID BREAK" 				,2,13,FONT,FNTSZ)
	symbol16X68( 48,80+(mode*200)	,localizedString("手札","hand")	,1,15,FONT,FNTSZ)
	symbol16X68(432,80+(mode*200)	,localizedString("台札","lead")	,1,15,FONT,FNTSZ)
endfunc

//****************************************************************
// 補助関数
//****************************************************************

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
// 毎回変わるので重要 / Important because stage is changed every time
	if touchallcnt>0 then {
		int i
		for i=1 to touchallcnt
			removeTouchArea(touchNo(i))
		next
		touchallcnt=0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
